package com.sxtvs.api.chatgpt.dto;

import lombok.Data;

import java.util.List;
import java.util.stream.Collectors;

@Data
public class CompletionsRequestDto {
    private List<Prompt> prompt;

    private String userId;
    private String userName;

    @Data
    public static class Prompt {
        private String text;
        private ItemType type;
    }

    public enum ItemType {
        user,
        robot
    }

    private String mergeText() {
        return prompt
                .stream()
                .map(CompletionsRequestDto.Prompt::getText)
                .collect(Collectors.joining("\n"));
    }


    public String toText() {
        var text = mergeText();
        // 文字过长后 就不携带上下文了 只保留最后一个问题
        if (text.length() > 2000) {
            for (int i = prompt.size() - 1; i >= 0; i--) {
                var p = prompt.get(i);
                if (p.type == ItemType.user) {
                    return p.text;
                }
            }
        }
        return text;
    }

}
